## org.eclipse.emf.cdo.spi.common.revision
Class AbstractCDORevision

    java.lang.Object
      org.eclipse.emf.cdo.spi.common.revision.AbstractCDORevision

All Implemented Interfaces:
  CDOReferenceAdjustable, CDORevision, CDORevisionData, InternalCDORevision

    public abstract class AbstractCDORevision

extends java.lang.Object
implements InternalCDORevision

Since:
  2.0

Field Summary

Fields inherited from interface org.eclipse.emf.cdo.spi.common.revision.InternalCDORevision
`NIL`

Fields inherited from interface org.eclipse.emf.cdo.common.revision.CDORevision
`UNCHUNKED, UNSPECIFIED_DATE, UNSPECIFIED_VERSION`

Constructor Summary
`AbstractCDORevision(AbstractCDORevision source)`
`AbstractCDORevision(CDODataInput in)`
`AbstractCDORevision(org.eclipse.emf.ecore.EClass eClass, CDOID id)`

Method Summary
`void` `add(org.eclipse.emf.ecore.EStructuralFeature feature, int index, java.lang.Object value)`
`void` `adjustReferences(CDOReferenceAdjuster revisionAdjuster)`
`protected java.lang.Object` `basicGet(org.eclipse.emf.ecore.EStructuralFeature feature)`
`java.lang.Object` `basicGet(org.eclipse.emf.ecore.EStructuralFeature feature, int index)` Use this method to retrieved `InternalCDORevision.NIL` object in some cases.
`java.lang.Object` `basicSet(org.eclipse.emf.ecore.EStructuralFeature feature, int index, java.lang.Object value)` Use this method to retrieved `InternalCDORevision.NIL` object in some cases.
`protected java.lang.Object` `basicSet(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)`
`static void` `checkNoFeatureMap(org.eclipse.emf.ecore.EStructuralFeature feature)`
`void` `clear(org.eclipse.emf.ecore.EStructuralFeature feature)`
`InternalCDORevisionDelta` `compare(CDORevision origin)`
`boolean` `contains(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)`
`protected java.lang.Object` `convertValue(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)`
`CDORevisionData` `data()`
`java.lang.Object` `get(org.eclipse.emf.ecore.EStructuralFeature feature, int index)`
`java.lang.Object` `getContainerID()`
`int` `getContainingFeatureID()`
`long` `getCreated()`
`org.eclipse.emf.ecore.EClass` `getEClass()`
`CDOID` `getID()`
`CDOList` `getList(org.eclipse.emf.ecore.EStructuralFeature feature)`
`CDOList` `getList(org.eclipse.emf.ecore.EStructuralFeature feature, int size)`
`CDOID` `getResourceID()`
`long` `getRevised()`
`java.lang.Object` `getValue(org.eclipse.emf.ecore.EStructuralFeature feature)` Should never return `InternalCDORevision.NIL`
`protected abstract java.lang.Object` `getValue(int featureIndex)`
`int` `getVersion()`
`int` `hashCode(org.eclipse.emf.ecore.EStructuralFeature feature)`
`int` `indexOf(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)`
`protected abstract void` `initValues(org.eclipse.emf.ecore.EStructuralFeature[] allPersistentFeatures)`
`boolean` `isCurrent()`
`boolean` `isEmpty(org.eclipse.emf.ecore.EStructuralFeature feature)`
`boolean` `isResource()`
`boolean` `isResourceFolder()`
`boolean` `isResourceNode()`
`boolean` `isTransactional()`
`boolean` `isValid(long timeStamp)`
`int` `lastIndexOf(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)`
`void` `merge(CDORevisionDelta delta)`
`java.lang.Object` `move(org.eclipse.emf.ecore.EStructuralFeature feature, int targetIndex, int sourceIndex)`
`static java.lang.Object` `remapID(java.lang.Object value, java.util.Map<CDOIDTemp,CDOID> idMappings)`
`java.lang.Object` `remove(org.eclipse.emf.ecore.EStructuralFeature feature, int index)`
`CDORevision` `revision()`
`java.lang.Object` `set(org.eclipse.emf.ecore.EStructuralFeature feature, int index, java.lang.Object value)`
`void` `setContainerID(java.lang.Object containerID)`
`void` `setContainingFeatureID(int containingFeatureID)`
`void` `setCreated(long created)`
`void` `setID(CDOID id)`
`void` `setList(org.eclipse.emf.ecore.EStructuralFeature feature, InternalCDOList list)`
`void` `setListSize(org.eclipse.emf.ecore.EStructuralFeature feature, int size)`
`void` `setResourceID(CDOID resourceID)`
`void` `setRevised(long revised)`
`int` `setTransactional()`
`void` `setUntransactional()`
`java.lang.Object` `setValue(org.eclipse.emf.ecore.EStructuralFeature feature, java.lang.Object value)`
`protected abstract void` `setValue(int featureIndex, java.lang.Object value)`
`void` `setVersion(int version)`
`int` `size(org.eclipse.emf.ecore.EStructuralFeature feature)`
`java.lang.Object[]` `toArray(org.eclipse.emf.ecore.EStructuralFeature feature)`

`

`<T> T[]`

`

`toArray(org.eclipse.emf.ecore.EStructuralFeature feature, T[] array)`

`java.lang.String` `toString()`
`void` `unset(org.eclipse.emf.ecore.EStructuralFeature feature)`
`void` `write(CDODataOutput out, int referenceChunk)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.eclipse.emf.cdo.common.revision.CDORevision
`copy`

Constructor Detail

### AbstractCDORevision

    public AbstractCDORevision(org.eclipse.emf.ecore.EClass eClass,
                               CDOID id)

### AbstractCDORevision

    public AbstractCDORevision(AbstractCDORevision source)

### AbstractCDORevision

    public AbstractCDORevision(CDODataInput in)
                        throws java.io.IOException

Throws:
  `java.io.IOException`

Method Detail

### write

    public void write(CDODataOutput out,
                      int referenceChunk)
               throws java.io.IOException

  Specified by:
    `write` in interface `InternalCDORevision`
  Throws:
    `java.io.IOException`

### getEClass

    public org.eclipse.emf.ecore.EClass getEClass()

  Specified by:
    `getEClass` in interface `CDORevision`

### getID

    public CDOID getID()

  Specified by:
    `getID` in interface `CDORevision`

### setID

    public void setID(CDOID id)

  Specified by:
    `setID` in interface `InternalCDORevision`

### getVersion

    public int getVersion()

  Specified by:
    `getVersion` in interface `CDORevision`

### setVersion

    public void setVersion(int version)

  Specified by:
    `setVersion` in interface `InternalCDORevision`

### isTransactional

    public boolean isTransactional()

  Specified by:
    `isTransactional` in interface `CDORevision`

### setTransactional

    public int setTransactional()

  Specified by:
    `setTransactional` in interface `InternalCDORevision`

### setUntransactional

    public void setUntransactional()

  Specified by:
    `setUntransactional` in interface `InternalCDORevision`

### getCreated

    public long getCreated()

  Specified by:
    `getCreated` in interface `CDORevision`

### setCreated

    public void setCreated(long created)

  Specified by:
    `setCreated` in interface `InternalCDORevision`

### getRevised

    public long getRevised()

  Specified by:
    `getRevised` in interface `CDORevision`

### setRevised

    public void setRevised(long revised)

  Specified by:
    `setRevised` in interface `InternalCDORevision`

### isCurrent

    public boolean isCurrent()

  Specified by:
    `isCurrent` in interface `CDORevision`

### isValid

    public boolean isValid(long timeStamp)

  Specified by:
    `isValid` in interface `CDORevision`

### isResourceNode

    public boolean isResourceNode()

  Specified by:
    `isResourceNode` in interface `CDORevision`

### isResourceFolder

    public boolean isResourceFolder()

  Specified by:
    `isResourceFolder` in interface `CDORevision`

### isResource

    public boolean isResource()

  Specified by:
    `isResource` in interface `CDORevision`

### data

    public CDORevisionData data()

  Specified by:
    `data` in interface `CDORevision`

### revision

    public CDORevision revision()

  Specified by:
    `revision` in interface `CDORevisionData`

### compare

    public InternalCDORevisionDelta compare(CDORevision origin)

  Specified by:
    `compare` in interface `CDORevision`

### merge

    public void merge(CDORevisionDelta delta)

  Specified by:
    `merge` in interface `CDORevision`

### getResourceID

    public CDOID getResourceID()

  Specified by:
    `getResourceID` in interface `CDORevisionData`

### setResourceID

    public void setResourceID(CDOID resourceID)

  Specified by:
    `setResourceID` in interface `InternalCDORevision`

### getContainerID

    public java.lang.Object getContainerID()

  Specified by:
    `getContainerID` in interface `CDORevisionData`

### setContainerID

    public void setContainerID(java.lang.Object containerID)

  Specified by:
    `setContainerID` in interface `InternalCDORevision`

### getContainingFeatureID

    public int getContainingFeatureID()

  Specified by:
    `getContainingFeatureID` in interface `CDORevisionData`

### setContainingFeatureID

    public void setContainingFeatureID(int containingFeatureID)

  Specified by:
    `setContainingFeatureID` in interface `InternalCDORevision`

### hashCode

    public int hashCode(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `hashCode` in interface `CDORevisionData`

### get

    public java.lang.Object get(org.eclipse.emf.ecore.EStructuralFeature feature,
                                int index)

  Specified by:
    `get` in interface `CDORevisionData`

### basicGet

    public java.lang.Object basicGet(org.eclipse.emf.ecore.EStructuralFeature feature,
                                     int index)

  Description copied from interface: `InternalCDORevision`
  Use this method to retrieved `InternalCDORevision.NIL` object in some cases.

  Specified by:
    `basicGet` in interface `InternalCDORevision`

### contains

    public boolean contains(org.eclipse.emf.ecore.EStructuralFeature feature,
                            java.lang.Object value)

  Specified by:
    `contains` in interface `CDORevisionData`

### indexOf

    public int indexOf(org.eclipse.emf.ecore.EStructuralFeature feature,
                       java.lang.Object value)

  Specified by:
    `indexOf` in interface `CDORevisionData`

### isEmpty

    public boolean isEmpty(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `isEmpty` in interface `CDORevisionData`

### lastIndexOf

    public int lastIndexOf(org.eclipse.emf.ecore.EStructuralFeature feature,
                           java.lang.Object value)

  Specified by:
    `lastIndexOf` in interface `CDORevisionData`

### size

    public int size(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `size` in interface `CDORevisionData`

### toArray

    public java.lang.Object[] toArray(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `toArray` in interface `CDORevisionData`

### toArray

    public <T> T[] toArray(org.eclipse.emf.ecore.EStructuralFeature feature,
                           T[] array)

  Specified by:
    `toArray` in interface `CDORevisionData`

### add

    public void add(org.eclipse.emf.ecore.EStructuralFeature feature,
                    int index,
                    java.lang.Object value)

  Specified by:
    `add` in interface `InternalCDORevision`

### clear

    public void clear(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `clear` in interface `InternalCDORevision`

### move

    public java.lang.Object move(org.eclipse.emf.ecore.EStructuralFeature feature,
                                 int targetIndex,
                                 int sourceIndex)

  Specified by:
    `move` in interface `InternalCDORevision`

### remove

    public java.lang.Object remove(org.eclipse.emf.ecore.EStructuralFeature feature,
                                   int index)

  Specified by:
    `remove` in interface `InternalCDORevision`

### set

    public java.lang.Object set(org.eclipse.emf.ecore.EStructuralFeature feature,
                                int index,
                                java.lang.Object value)

  Specified by:
    `set` in interface `InternalCDORevision`

### basicSet

    public java.lang.Object basicSet(org.eclipse.emf.ecore.EStructuralFeature feature,
                                     int index,
                                     java.lang.Object value)

  Description copied from interface: `InternalCDORevision`
  Use this method to retrieved `InternalCDORevision.NIL` object in some cases.

  Specified by:
    `basicSet` in interface `InternalCDORevision`

### unset

    public void unset(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `unset` in interface `InternalCDORevision`

### adjustReferences

    public void adjustReferences(CDOReferenceAdjuster revisionAdjuster)

  Specified by:
    `adjustReferences` in interface `CDOReferenceAdjustable`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### getValue

    public java.lang.Object getValue(org.eclipse.emf.ecore.EStructuralFeature feature)

  Description copied from interface: `InternalCDORevision`
  Should never return `InternalCDORevision.NIL`

  Specified by:
    `getValue` in interface `InternalCDORevision`

### setValue

    public java.lang.Object setValue(org.eclipse.emf.ecore.EStructuralFeature feature,
                                     java.lang.Object value)

  Specified by:
    `setValue` in interface `InternalCDORevision`

### convertValue

    protected java.lang.Object convertValue(org.eclipse.emf.ecore.EStructuralFeature feature,
                                            java.lang.Object value)

### basicGet

    protected java.lang.Object basicGet(org.eclipse.emf.ecore.EStructuralFeature feature)

### basicSet

    protected java.lang.Object basicSet(org.eclipse.emf.ecore.EStructuralFeature feature,
                                        java.lang.Object value)

### getList

    public CDOList getList(org.eclipse.emf.ecore.EStructuralFeature feature)

  Specified by:
    `getList` in interface `InternalCDORevision`

### getList

    public CDOList getList(org.eclipse.emf.ecore.EStructuralFeature feature,
                           int size)

  Specified by:
    `getList` in interface `InternalCDORevision`
    `size` - the size of a new list to be created if this revision has no list so far, or -1 to skip list creation and return `null` in this case.

### setList

    public void setList(org.eclipse.emf.ecore.EStructuralFeature feature,
                        InternalCDOList list)

  Specified by:
    `setList` in interface `InternalCDORevision`

### setListSize

    public void setListSize(org.eclipse.emf.ecore.EStructuralFeature feature,
                            int size)

  Specified by:
    `setListSize` in interface `InternalCDORevision`

### initValues

    protected abstract void initValues(org.eclipse.emf.ecore.EStructuralFeature[] allPersistentFeatures)

### getValue

    protected abstract java.lang.Object getValue(int featureIndex)

### setValue

    protected abstract void setValue(int featureIndex,
                                     java.lang.Object value)

### checkNoFeatureMap

    public static void checkNoFeatureMap(org.eclipse.emf.ecore.EStructuralFeature feature)

### remapID

    public static java.lang.Object remapID(java.lang.Object value,
                                           java.util.Map<CDOIDTemp,CDOID> idMappings)

Copyright (c) 2004 - 2009 Eike Stepper (Berlin, Germany) and others. All Rights Reserved.